<?php
namespace Ak\Form\Annotation;

use Laminas\Form\Annotation\ElementAnnotationsListener as BaseElementAnnotationsListener;
use Laminas\Form\Annotation\Exclude;

/**
 * Class ElementAnnotationsListener
 *
 * @package Ak\Form\Annotation
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
final class ElementAnnotationsListener extends BaseElementAnnotationsListener
{
    use AnnotationsListenerTrait;

    /**
     * Determine if the element has been marked to exclude from the definition
     *
     * @param  \Laminas\EventManager\EventInterface $e
     * @return bool
     */
    public function handleExcludeAnnotation($e)
    {
        $annotations = $e->getParam('annotations');

        foreach ($annotations as $annotation) {
            if ($annotation instanceof Exclude) {
                return true;
            }
        }

        return false;
    }
}
