<?php
namespace Ak\Form\Annotation;

use Laminas\EventManager\EventManagerInterface;
use Laminas\Form\Annotation\FormAnnotationsListener as BaseFormAnnotationsListener;

/**
 * Class FormAnnotationsListener
 *
 * @package Ak\Form\Annotation
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
final class FormAnnotationsListener extends BaseFormAnnotationsListener
{
    use AnnotationsListenerTrait;

    /**
     * Attach listeners
     *
     * @param  EventManagerInterface $events
     * @param int $priority
     * @return void
     */
    public function attach(EventManagerInterface $events, $priority = 1)
    {
        $this->listeners[] = $events->attach('configureForm', [$this, 'handleAttributesAnnotation'], $priority);
        $this->listeners[] = $events->attach('configureForm', [$this, 'handleFlagsAnnotation'], $priority);
        $this->listeners[] = $events->attach('configureForm', [$this, 'handleHydratorAnnotation'], $priority);
        $this->listeners[] = $events->attach('configureForm', [$this, 'handleInputFilterAnnotation'], $priority);
        $this->listeners[] = $events->attach('configureForm', [$this, 'handleObjectAnnotation'], $priority);
        $this->listeners[] = $events->attach('configureForm', [$this, 'handleOptionsAnnotation'], $priority);
        $this->listeners[] = $events->attach('configureForm', [$this, 'handleTypeAnnotation'], $priority);
        $this->listeners[] = $events->attach('configureForm', [$this, 'handleValidationGroupAnnotation'], $priority);

        $this->listeners[] = $events->attach('discoverName', [$this, 'handleNameAnnotation'], $priority);
        $this->listeners[] = $events->attach('discoverName', [$this, 'discoverFallbackName'], $priority);
    }
}
