<?php
namespace Ak\Form;

use Laminas\Form\ElementInterface as BaseElementInterface;

/**
 * Element HTML obrasca.
 *
 * @package Ak\Form
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
interface ElementInterface extends BaseElementInterface
{
    /**
     * Vraća ID atribut. Ako ne postoji automatski se generira.
     *
     * @return string
     */
    public function getId(): string;

    /**
     * Vraća tekst dodatnih informacija za element.
     *
     * @return null|string
     */
    public function getAdditionalInfo(): ?string;

    /**
     * Postavlja tekst dodatnih informacija za element.
     *
     * @param string $helpText
     */
    public function setAdditionalInfo(string $helpText): void;
}
