<?php
namespace Ak\Form\View\Helper;

use Laminas\Form\FieldsetInterface;
use Laminas\Form\FormInterface;
use Laminas\Form\View\Helper\Form as BaseForm;

/**
 * Renderira HTML obrazac.
 *
 * @package Ak\Form\View\Helper
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
class Form extends BaseForm
{
    use HelperTools;

	/**
	 * Render a form from the provided $form,
	 *
	 * @param  FormInterface $form
	 * @return string
	 */
	public function render(FormInterface $form)
	{
		if (method_exists($form, 'prepare')) {
			$form->prepare();
		}

		$this->addCssClass($form, 'Form');
		$form->setAttribute('novalidate', true);

		$formContent = '';

		foreach ($form as $element) {
			if ($element instanceof FieldsetInterface) {
				/** @noinspection PhpUndefinedMethodInspection */
				$formContent .= $this->getView()->form_collection($element);
			} else {
				/** @noinspection PhpUndefinedMethodInspection */
				$formContent .= $this->getView()->form_element($element);
			}
		}

		return $this->openTag($form) . $formContent . $this->closeTag();
	}
}
