<?php
namespace Ak\Form\View\Helper;

use Ak\Form\Element\Button;
use Laminas\Form\Element\Select;
use Laminas\Form\View\Helper\FormElement as BaseFormElement;

/**
 * Delegira renderiranje drugom helperu, ovisno o elementu.
 *
 * @package Ak\Form\View\Helper
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
final class FormElementDelegate extends BaseFormElement
{
    const DEFAULT_HELPER = 'form_input';

    /**
     * Instance map to view helper
     *
     * @var array
     */
    protected $classMap = [
        Button::class => 'form_button',
        Select::class => 'form_select',
    ];

    /** @var array */
    protected $typeMap = [
        'checkbox' => 'form_checkbox',
        'button' => 'form_button',
        'multi_checkbox' => 'form_multi_checkbox',
        'submit' => 'form_button',
        'textarea' => 'form_textarea',
    ];

    /** @var string */
    protected $defaultHelper = self::DEFAULT_HELPER;
}
