<?php
namespace Ak\Form\View\Helper;

use Ak\View\Helper\Icon;
use Ak\View\IconAwareInterface;
use Laminas\Form\ElementInterface;
use Laminas\Form\View\Helper\AbstractHelper;

/**
 * Renderira ikonu elementa.
 *
 * @package Ak\Form\View\Helper
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
final class FormIcon extends AbstractHelper
{
    /** @var Icon */
    protected $iconHelper;

    /**
     * @return Icon
     */
    protected function getIconHelper()
    {
        if (null === $this->iconHelper) {
            $this->iconHelper = method_exists($this->view, 'plugin')
                ? $this->view->plugin('icon')
                : new Icon();
        }

        return $this->iconHelper;
    }

    public function __invoke(ElementInterface $element)
    {
        if ($element instanceof IconAwareInterface && strlen($element->getIcon()) > 0) {
            $iconHelper = $this->getIconHelper();
            return $iconHelper($element->getIcon());
        }

        return '';
    }
}
