<?php
namespace AkTest\Form\Annotation;

use Laminas\Form\Annotation as Form;

/**
 * Class ParentObject
 *
 * @package AkTest\Form\Annotation
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/wp-core
 *
 * @Form\Type("Laminas\Form\Form")
 * @Form\Attributes({"data-class":"AkTest\Form\Annotation\ParentObject"})
 */
class ParentObject
{
    /**
     * @var string
     *
     * @Form\Type("text")
     */
    private $parentName;

    /**
     * @var ChildObject
     *
     * @Form\Type("AkTest\Form\Annotation\ChildObject")
     * @Form\Options({
     *      "label": "Child label"
     * })
     */
    private $child;

    /**
     * @return string
     */
    public function getParentName(): string
    {
        return $this->parentName;
    }

    /**
     * @return ChildObject
     */
    public function getChild(): ChildObject
    {
        return $this->child;
    }
}
