<?php
namespace AkTest\Form\View\Helper;

use Ak\Form\Element\Checkbox;
use Ak\Form\View\Helper\FormAdditionalInfo;
use AkTest\Form\AbstractTestCase;

class AdditionalInfoTest extends AbstractTestCase
{
    public function testIsRegistered()
    {
        $manager = $this->getHelperPluginManager();

        $this->assertTrue($manager->has('form_additional_info'));
        $this->assertInstanceOf(FormAdditionalInfo::class, $manager->get('form_additional_info'));
    }

    public function testWillRenderTheInfo()
    {
        $helper = new FormAdditionalInfo();

        $element = new Checkbox('checkbox', [
            'additional_info' => 'information',
        ]);

        $rendered = $helper($element);

        $this->assertSelectCount('div.FormControl__AdditionalInfo', 1, $rendered);
        $this->assertEquals('information', strip_tags($rendered));
    }
}