<?php
namespace AkTest\Form\View\Helper;

use AkTest\Form\AbstractTestCase;
use Laminas\Form\Element\Text;
use Laminas\Form\Fieldset;
use Laminas\ServiceManager\PluginManagerInterface;
use Laminas\View\HelperPluginManager;
use Laminas\View\Renderer\RendererInterface;

/**
 * Class FormCollectionTest
 *
 * @package AkTest\Form\View\Helper
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
class CollectionTest extends AbstractTestCase
{
    public function testHelperUsesTheProperFormGroupHelper()
    {
        $container = $this->getContainer();
        $container->get(RendererInterface::class);

        /** @var PluginManagerInterface $helpers */
        $helpers = $container->get(HelperPluginManager::class);

        $fieldset = new Fieldset('test');
        $fieldset->add(new Text('test-text'));

        $helper = $helpers->get('form_collection');
        $rendered = $helper($fieldset);

        /** @noinspection PhpParamsInspection */
        $this->assertSelectCount('fieldset.Fieldset', 1, $rendered);
        /** @noinspection PhpParamsInspection */
        $this->assertSelectCount('div.FormElement', 1, $rendered);
    }
}
