<?php
namespace Ak\Form\View\Helper;

use AkTest\Form\AbstractTestCase;
use AkTest\Form\Mock\HelperInterface;
use Laminas\Form\Element\Checkbox;

/**
 * Class FormElementTest
 *
 * @package Ak\Form\View\Helper
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
class ElementDelegateTest extends AbstractTestCase
{
    public function testIsRegistered()
    {
        $manager = $this->getHelperPluginManager();

        $this->assertContainerHasService($manager, [
            'form_element_delegate',
            FormElementDelegate::class,
        ], FormElementDelegate::class, true);
    }

    public function testCorrectHelperIsCalledForCheckbox()
    {
        $checkbox = new Checkbox();

        $checkboxHelper = $this->createMock(HelperInterface::class);
        $checkboxHelper->expects($this->once())
            ->method('__invoke')
            ->with($checkbox)
            ->willReturn('');

        $manager = $this->getHelperPluginManager();
        $manager->setService(FormCheckbox::class, $checkboxHelper);

        $helper = $manager->get('form_element_delegate');

        $helper($checkbox);
    }
}
