<?php
namespace AkTest\Form\View\Helper;

use Ak\Form\View\Helper\FormElementErrors;
use AkTest\Form\AbstractTestCase;
use Laminas\Form\Element\Text;

/**
 * Class FormElementErrorsTest
 *
 * @package AkTest\Form\View\Helper
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
class ElementErrorsTest extends AbstractTestCase
{
    public function testIsRegistered()
    {
        $manager = $this->getHelperPluginManager();

        $this->assertTrue($manager->has('form_element_errors'));
        $this->assertInstanceOf(FormElementErrors::class, $manager->get('form_element_errors'));
    }

    public function testErrorsAreRendered()
    {
        $helper = new FormElementErrors();

        $element = new Text('text');
        $element->setMessages([
            'message 1',
            'message 2',
        ]);

        $rendered = $helper($element);

        $this->assertSelectCount('ul.FormElementErrors', 1, $rendered);
        $this->assertSelectCount('ul.FormElementErrors > li.FormElementErrors__Error', 2, $rendered);
        $this->assertEquals('message 1message 2', strip_tags($rendered));
    }
}
